<script setup lang="ts">
import { onMounted, reactive } from 'vue'
import { Modal } from 'flowbite'
import { globalErrorMessage, useAppStore } from '@/stores/app'

let modal: Modal | null = null
const data = reactive({
  message: null as string | null
})

const app = useAppStore()
app.$subscribe(() => {
  const globalErrorDisplayed = !!app.globalError
  if (modal!.isVisible() !== globalErrorDisplayed) {
    if (globalErrorDisplayed) {
      data.message = globalErrorMessage(app.globalError!)
      modal!.show()
    } else {
      modal!.hide()
    }
  }
})

onMounted(() => {
  const $modalElement: HTMLElement | null = document.querySelector('#popup-modal')

  const modalOptions = {
    backdropClasses: 'bg-gray-900/50 dark:bg-gray-900/80 fixed inset-0 z-40'
  }

  if ($modalElement) {
    modal = new Modal($modalElement, modalOptions)
    modal.updateOnHide(() => app.setGlobalError(null))
  }
})

function hideModal() {
  app.setGlobalError(null)
  modal!.hide()
}
</script>

<template>
  <div
    id="popup-modal"
    tabindex="-1"
    class="hidden overflow-y-auto overflow-x-hidden fixed top-0 right-0 left-0 z-50 justify-center items-center w-full md:inset-0 h-[calc(100%-1rem)] max-h-full"
  >
    <div class="relative p-4 w-full max-w-md max-h-full">
      <div class="relative bg-white rounded-lg shadow dark:bg-gray-700">
        <button
          type="button"
          class="absolute top-3 end-2.5 text-gray-400 bg-transparent hover:bg-gray-200 hover:text-gray-900 rounded-lg text-sm w-8 h-8 ms-auto inline-flex justify-center items-center dark:hover:bg-gray-600 dark:hover:text-white"
          @click="hideModal"
        >
          <svg
            class="w-3 h-3"
            aria-hidden="true"
            xmlns="http://www.w3.org/2000/svg"
            fill="none"
            viewBox="0 0 14 14"
          >
            <path
              stroke="currentColor"
              stroke-linecap="round"
              stroke-linejoin="round"
              stroke-width="2"
              d="m1 1 6 6m0 0 6 6M7 7l6-6M7 7l-6 6"
            />
          </svg>
          <span class="sr-only">Close modal</span>
        </button>
        <div class="p-4 md:p-5 text-center">
          <svg
            class="mx-auto mb-4 text-gray-400 w-12 h-12 dark:text-gray-200"
            aria-hidden="true"
            xmlns="http://www.w3.org/2000/svg"
            fill="none"
            viewBox="0 0 20 20"
          >
            <path
              stroke="currentColor"
              stroke-linecap="round"
              stroke-linejoin="round"
              stroke-width="2"
              d="M10 11V6m0 8h.01M19 10a9 9 0 1 1-18 0 9 9 0 0 1 18 0Z"
            />
          </svg>
          <h3 class="whitespace-pre-line mb-5 text-lg font-normal text-gray-500 dark:text-gray-400">
            {{ data.message }}
          </h3>
          <button
            @click="hideModal"
            type="button"
            class="py-2.5 px-5 ms-3 text-sm font-medium text-gray-900 focus:outline-none bg-white rounded-lg border border-gray-200 hover:bg-gray-100 hover:text-blue-700 focus:z-10 focus:ring-4 focus:ring-gray-100 dark:focus:ring-gray-700 dark:bg-gray-800 dark:text-gray-400 dark:border-gray-600 dark:hover:text-white dark:hover:bg-gray-700"
          >
            {{ $t('ui.close') }}
          </button>
        </div>
      </div>
    </div>
  </div>
</template>
